--
-- MPLogin
--
-- @author  Destroileur
-- Version 1.0
-- @date 16.12.2017

ClientControllerEvent = {};
ClientControllerEvent_mt = Class(ClientControllerEvent, Event);
InitEventClass(ClientControllerEvent, "ClientControllerEvent");


function ClientControllerEvent:emptyNew()
    local self = Event:new(ClientControllerEvent_mt);
    return self;
end;

function ClientControllerEvent:new(actionTarget, actionType, actionData)
    local self = ClientControllerEvent:emptyNew(); 
    self.actionTarget = actionTarget; 
    self.actionType = actionType; 
	self.actionData = actionData; 
    return self;
end;

function ClientControllerEvent:writeStream(streamId, connection)
    streamWriteString(streamId, self.actionTarget);
	streamWriteString(streamId, self.actionType);
	streamWriteString(streamId, self.actionData);
end;

function ClientControllerEvent:readStream(streamId, connection)
	self.actionTarget = streamReadString(streamId); 
    self.actionType = streamReadString(streamId); 
	self.actionData = streamReadString(streamId); 
    self:run(connection);
end;

function ClientControllerEvent:run(connection)
	MPLogin:ClientController(self.actionTarget, self.actionType, self.actionData);
	if not connection:getIsServer() then
		g_server:broadcastEvent(ClientControllerEvent:new(self.actionTarget, self.actionType, self.actionData), nil, connection, nil);
	end; 
end;

function ClientControllerEvent.sendEvent(actionTarget, actionType, actionData)
	g_server:broadcastEvent(ClientControllerEvent:new(actionTarget, actionType, actionData), nil, nil, nil); 
end;