--
-- MPLogin
--
-- @author  Destroileur
-- Version 1.0
-- @date 16.12.2017

ServerControllerEvent = {};
ServerControllerEvent_mt = Class(ServerControllerEvent, Event);
InitEventClass(ServerControllerEvent, "ServerControllerEvent");


function ServerControllerEvent:emptyNew()
    local self = Event:new(ServerControllerEvent_mt);
    return self;
end;

function ServerControllerEvent:new(actionSender, actionType, actionData)
    local self = ServerControllerEvent:emptyNew(); 
	self.actionSender = actionSender; 
    self.actionType = actionType; 
	self.actionData = actionData;
    return self;
end;

function ServerControllerEvent:writeStream(streamId, connection)
	streamWriteString(streamId, self.actionSender);
	streamWriteString(streamId, self.actionType);
	streamWriteString(streamId, self.actionData);
end;

function ServerControllerEvent:readStream(streamId, connection)
    self.actionSender = streamReadString(streamId); 
    self.actionType = streamReadString(streamId); 
	self.actionData = streamReadString(streamId);
    self:run(connection);
end;

function ServerControllerEvent:run(connection)
	MPLogin:ServerController(self.actionSender, self.actionType, self.actionData);
end;

function ServerControllerEvent.sendEvent(actionSender, actionType, actionData)
	g_client:getServerConnection():sendEvent(ServerControllerEvent:new(actionSender, actionType, actionData)); 
end;